﻿
<div class="container">
    <div class="row">
        <div class="col-2">
            <TabMenu Parent="this" />
        </div>
        <div class="col-10">
            <div class="mb-2">
                @foreach (string tabPageName in Pages.Where(x => x.IsVisible).Select(x => x.Name))
                {
                    <div class="btn-group mr-1" role="group">
                        <button type="button"
                                class="btn btn-sm @GetButtonClass(tabPageName)"
                                @onclick=@( () => ActivatePage(tabPageName) )>
                            @tabPageName
                        </button>
                        <button type="button"
                                class="btn btn-sm @GetButtonClass(tabPageName)"
                                @onclick=@( () => ClosePage(tabPageName) )>
                            x
                        </button>
                    </div>
                }
            </div>
            
            <CascadingValue Value="this">
                @ChildContent
            </CascadingValue>

            @if (ActivePage != null)
            {
                <div>
                    @ActivePage.ChildContent
                </div>
            }
        </div>
    </div>
</div>

@code {

    [Parameter]
    public RenderFragment ChildContent { get; set; }

    string GetButtonClass(string tabPageName)
    {
        return tabPageName == (ActivePage?.Name ?? string.Empty) ? "btn-primary" : "btn-secondary";
    }

    public TabPage ActivePage { get; set; }
    public List<TabPage> Pages = new List<TabPage>();

    public void AddPage(TabPage tabPage)
    {
        Pages.Add(tabPage);
        StateHasChanged();
    }

    public void ActivatePage(string pageName)
    {
        ActivePage = Pages.FirstOrDefault(x => x.Name == pageName);
        ActivePage.IsVisible = true;
        StateHasChanged();
    }

    public void ClosePage(string pageName)
    {
        TabPage closedPage = Pages.Single(x => x.Name == pageName);
        closedPage.IsVisible = false;
        if (ActivePage != null && ActivePage.Name == pageName)
        {
            ActivePage = null;
        }
    }

}
